library filewatch;

{$R *.res}

uses
  SysUtils,Windows,Messages,Classes;

{
FILE_NOTIFY_CHANGE_FILE_NAME    =$00000001
FILE_NOTIFY_CHANGE_DIR_NAME     =$00000002
FILE_NOTIFY_CHANGE_ATTRIBUTES   =$00000004
FILE_NOTIFY_CHANGE_SIZE         =$00000008
FILE_NOTIFY_CHANGE_LAST_WRITE   =$00000010
FILE_NOTIFY_CHANGE_LAST_ACCESS  =$00000020
FILE_NOTIFY_CHANGE_CREATION     =$00000040
FILE_NOTIFY_CHANGE_SECURITY     =$00000100
}
type
  
  // FindFirstChangeNotification fBNĝ
  TFileWatchThread = class(TThread)
  private
    { Private 錾 }
    FPath:String;
    FHwnd:HWND;
    FFlag:DWORD;
    FSubtree:Bool;
  protected
    procedure Execute; override;
  public
    constructor Create(path:string;subtree:Bool;flag:DWORD;h:hwnd);
    procedure Test;
  end;
  PFileWatchThread = ^TFileWatchThread;

  // ReadDirectotyChangesW NTp
(*
  TFileWatchThread2 = class(TThread)
  private
    { Private 錾 }
    FPath:String;
    FHwnd:HWND;
    FFlag:DWORD;
    //FSubtree:Bool;
    FName:string;
  protected
    procedure Execute; override;
  public
    constructor Create(path:string;name:string;flag:DWORD;h:hwnd);
    procedure Test;
  end;
  PFileWatchThread2 = ^TFileWatchThread2;
*)
  // FindFirstChangeNotification + FindFirstFile t@CΉ
  TFileWatchThread3 = class(TThread)
  private
    { Private 錾 }
    FPath:String;
    FHwnd:HWND;
    FFlag:DWORD;
    //FSubtree:Bool;
    FName:string;
  protected
    procedure Execute; override;
  public
    constructor Create(path,name:string;flag:DWORD;h:hwnd);
    procedure Test;
  end;
  PFileWatchThread3 = ^TFileWatchThread3;

  TThreadList = class
  private
    FList:array of TThread;
    FCapacity:integer;
    FCount:integer;
    FDeleted:integer;
    procedure Grow;
  public
    function Add(t:TThread):integer;
    procedure Delete(i:integer);
    function Get(i:integer):TThread;
    constructor Create;
    destructor Destory;
  end;

  FILE_NOTIFY_INFORMATION = record
    NextEntryOffset:DWORD;
    Action:DWORD;
    FileNameLength:DWORD;
    FileName:WideChar;
  end;
  PFILE_NOTIFY_INFORMATION = ^FILE_NOTIFY_INFORMATION;

var
 list:TThreadList;

{ TThreadList }
constructor TThreadList.Create;
begin
  Fcount:=0;
  FDeleted:=0;
  FCapacity:=0;
  Grow;
end;

destructor TThreadList.Destory;
var
 i:integer;
begin
  for i:=0 to FCount-1 do
  begin
    if FList[i] <> nil then
      FList[i].Terminate;
  end;
end;

procedure TThreadList.Grow;
var
  i:integer;
begin
  Inc(FCapacity,5);
  SetLength(flist,FCapacity);
  for i := FCapacity-1 downto FCapacity-5 do
    FList[i] := nil;
end;

function TThreadList.Add(t:TThread):integer;
var
  i:integer;
begin
  result:=-1;
  if fdeleted = 0 then
  begin
    if FCount >= FCapacity then
      Grow;
    FList[Fcount] := t;
    Result := FCount;
    Inc(FCount);
  end
  else
  begin
    for i:=0 to Fcount do
    begin
      if FList[i] = nil then
      begin
        FList[i] := t;
        Result := i;
        Dec(FDeleted);
        break;
      end;
    end;
  end;
end;

procedure TThreadList.Delete(i:integer);
begin
  if (0 <= i) and (i < FCount) then
  begin
    if FList[i] <> nil then
    begin
      FList[i].Terminate;
      FList[i] := nil;
      Inc(FDeleted);
    end;
  end;
end;

function TThreadList.Get(i:integer):TThread;
begin
  if (0 <= i) and (i < FCount) then
  begin
    Result:=FList[i];
  end
  else
    Result:=nil;
end;

{ TFileWatchThread }
procedure TFileWatchThread.Test;
begin
  MessageBox(0,PChar('path: '+FPath+#13#10+
  'hwnd: '+IntToStr(FHwnd)+#13#10+
  'Flag: '+IntToHex(FFlag,8)+#13#10+
  'Sub: '+BoolToStr(FSubtree)),'title',MB_OK);
end;

procedure TFileWatchThread.Execute;
var
  handle:THandle;
  CD:COPYDATASTRUCT;
  Str:String;
begin
  handle := FindFirstChangeNotification(PChar(FPath),FSubtree,FFlag);
  if handle = INVALID_HANDLE_VALUE then
  begin
    //Direct SSTP M
    Str:='NOTIFY SSTP/1.1'#13#10+
         'Sender: FileWatchSaori'#13#10+
         'Event: OnFileWatchError'#13#10+
         'Reference0: '+FPath+ #13#10+
         'Reference1: FindFirstChangeNotification'#13#10+
         'Reference2: '+IntToStr(GetLastError)+ #13#10+
         'HWnd: 0'#13#10+
         'Charset: Shift_JIS'#13#10#13#10;
    CD.dwData := 9801;
    CD.cbData := Length(Str);
    CD.lpData := PChar(Str);

    SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
    Exit;
  end;
  while not Terminated do
  begin
    if WaitForSingleObject(handle,3000) = WAIT_OBJECT_0 then
    begin
      //Direct SSTP M
      Str:='NOTIFY SSTP/1.1'#13#10+
           'Sender: FileWatchSaori'#13#10+
           'Event: OnFileWatchChangeNotify'#13#10+
           'Reference0: '+FPath+ #13#10+
           'HWnd: 0'#13#10+
           'Charset: Shift_JIS'#13#10#13#10;
      CD.dwData := 9801;
      CD.cbData := Length(Str);
      CD.lpData := PChar(Str);

      SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
    end;

    if FindNextChangeNotification(handle) = false then
    begin
      //Direct SSTP M
      Str:='NOTIFY SSTP/1.1'#13#10+
           'Sender: FileWatchSaori'#13#10+
           'Event: OnFileWatchError'#13#10+
           'Reference0: '+FPath+ #13#10+
           'Reference1: FindNextChangeNotification'#13#10+
           'Reference2: '+IntToStr(GetLastError)+ #13#10+
           'HWnd: 0'#13#10+
           'Charset: Shift_JIS'#13#10#13#10;
      CD.dwData := 9801;
      CD.cbData := Length(Str);
      CD.lpData := PChar(Str);

      SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
      Break;
    end
  end;
  //MessageBox(0,'Thread End','a',0);
  FindCloseChangeNotification(handle);
end;

constructor TFileWatchThread.Create(path:string;subtree:Bool;flag:DWORD;h:hwnd);
begin
  FPath := path;
  FSubtree := subtree;
  FFlag := flag;
  FHwnd := h;
  FreeOnTerminate:=True;

  inherited Create(False);
end;

{ TFileWatchThread3 }
procedure TFileWatchThread3.Test;
begin
  MessageBox(0,PChar('path: '+FPath+#13#10+
  'hwnd: '+IntToStr(FHwnd)+#13#10+
  'Flag: '+IntToHex(FFlag,8)+#13#10+
  'Sub: '+Fname),'title',MB_OK);
end;

procedure TFileWatchThread3.Execute;
var
  handle,hfile:THandle;
  CD:COPYDATASTRUCT;
  changed:Boolean;
  Str,item,fullpath:String;
  OLD_FIND_DATA,NEW_FIND_DATA:WIN32_FIND_DATA;
begin
  fullpath := Fpath+'\'+Fname;
  hfile  := FindFirstFile(PChar(fullpath),OLD_FIND_DATA);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    //Direct SSTP M
    Str:='NOTIFY SSTP/1.1'#13#10+
         'Sender: FileWatchSaori'#13#10+
         'Event: OnFileWatchError'#13#10+
         'Reference0: '+fullpath+#13#10+
         'Reference1: FindFirstFile'#13#10+
         'Reference2: '+IntToStr(GetLastError)+ #13#10+
         'HWnd: 0'#13#10+
         'Charset: Shift_JIS'#13#10#13#10;
    CD.dwData := 9801;
    CD.cbData := Length(Str);
    CD.lpData := PChar(Str);

    SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
    Exit;
  end;
  FindClose(hfile);

  handle := FindFirstChangeNotification(PChar(FPath),false,FFlag);
  if handle = INVALID_HANDLE_VALUE then
  begin
    //Direct SSTP M
    Str:='NOTIFY SSTP/1.1'#13#10+
         'Sender: FileWatchSaori'#13#10+
         'Event: OnFileWatchError'#13#10+
         'Reference0: '+fullpath+#13#10+
         'Reference1: FindFirstChangeNotification'#13#10+
         'Reference2: '+IntToStr(GetLastError)+ #13#10+
         'HWnd: 0'#13#10+
         'Charset: Shift_JIS'#13#10#13#10;
    CD.dwData := 9801;
    CD.cbData := Length(Str);
    CD.lpData := PChar(Str);

    SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
    Exit;
  end;

  while not Terminated do
  begin
    changed := False;
    if WaitForSingleObject(handle,3000) = WAIT_OBJECT_0 then
    begin
      hfile := FindFirstFile(PChar(fullpath),NEW_FIND_DATA);
      //MessageBox(0,@NEW_FIND_DATA.cAlternateFileName,'',0);
      if hfile = INVALID_HANDLE_VALUE then
      begin
        // t@CȂ܂薼OύXꂽ
        // t@CύXꂽǐՕs
        if (fflag and FILE_NOTIFY_CHANGE_FILE_NAME) <> 0 then
        begin
          item := 't@CύX';
          Str:='NOTIFY SSTP/1.1'#13#10+
               'Sender: FileWatchSaori'#13#10+
               'Event: OnFileWatchChangeNotify'#13#10+
               'Reference0: '+fullpath+ #13#10+
               'Reference1: '+item+ #13#10+
               'HWnd: 0'#13#10+
               'Charset: Shift_JIS'#13#10#13#10;
        end else
        begin
          Str:='NOTIFY SSTP/1.1'#13#10+
               'Sender: FileWatchSaori'#13#10+
               'Event: OnFileWatchError'#13#10+
               'Reference0: '+fullpath+#13#10+
               'Reference1: FindFirst'#13#10+
               'Reference2: '+IntToStr(GetLastError)+ #13#10+
               'HWnd: 0'#13#10+
               'Charset: Shift_JIS'#13#10#13#10;
        end;
        CD.dwData := 9801;
        CD.cbData := Length(Str);
        CD.lpData := PChar(Str);

        SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
        break;
      end else if (fflag and FILE_NOTIFY_CHANGE_ATTRIBUTES) <> 0 then
      begin
        if NEW_FIND_DATA.dwFileAttributes <>
           OLD_FIND_DATA.dwFileAttributes
        then
        begin
          changed := true;
          item := 't@C';
        end;
      end
      else if (fflag and FILE_NOTIFY_CHANGE_SIZE) <> 0 then
      begin
        if (NEW_FIND_DATA.nFileSizeLow  <> OLD_FIND_DATA.nFileSizeLow) or
           (NEW_FIND_DATA.nFileSizeHigh <> OLD_FIND_DATA.nFileSizeHigh)
        then
        begin
          {MessageBox(0,PChar(IntToStr(NEW_FIND_DATA.nFileSizeLow)),'',0);
          MessageBox(0,PChar(IntToStr(OLD_FIND_DATA.nFileSizeLow)),'',0);
          MessageBox(0,PChar(IntToStr(NEW_FIND_DATA.nFileSizeHigh)),'',0);
          MessageBox(0,PChar(IntToStr(OLD_FIND_DATA.nFileSizeHigh)),'',0);}
          changed := true;
          item := 't@CTCY';
        end;
      end
      else if (fflag and FILE_NOTIFY_CHANGE_LAST_WRITE) <> 0 then
      begin
        if (NEW_FIND_DATA.ftLastWriteTime.dwLowDateTime <>
            OLD_FIND_DATA.ftLastWriteTime.dwLowDateTime) or
           (NEW_FIND_DATA.ftLastWriteTime.dwHighDateTime <>
            OLD_FIND_DATA.ftLastWriteTime.dwHighDateTime)
        then
        begin
          changed := true;
          item := 't@Cݓ';
        end;
      end;

      //ȂFindNextFileȂƌ댟o
      //댟ot@CTCY0Ƃĕ񍐂
      FindNextFile(hfile,NEW_FIND_DATA);
      //MessageBox(0,@NEW_FIND_DATA.cAlternateFileName,'',0);
      Windows.FindClose(hfile);

      Move(NEW_FIND_DATA,OLD_FIND_DATA,sizeof(WIN32_FIND_DATA));

      if changed then
      begin
        //Direct SSTP M
        Str:='NOTIFY SSTP/1.1'#13#10+
             'Sender: FileWatchSaori'#13#10+
             'Event: OnFileWatchChangeNotify'#13#10+
             'Reference0: '+fullpath+#13#10+
             'Reference1: '+item+#13#10+
             'HWnd: 0'#13#10+
             'Charset: Shift_JIS'#13#10#13#10;
        CD.dwData := 9801;
        CD.cbData := Length(Str);
        CD.lpData := PChar(Str);

        SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
      end;
    end;

    if FindNextChangeNotification(handle) = false then
    begin
      //Direct SSTP M
      Str:='NOTIFY SSTP/1.1'#13#10+
           'Sender: FileWatchSaori'#13#10+
           'Event: OnFileWatchError'#13#10+
           'Reference0: '+fullpath+#13#10+
           'Reference1: FindNextChangeNotification'#13#10+
           'Reference2: '+IntToStr(GetLastError)+ #13#10+
           'HWnd: 0'#13#10+
           'Charset: Shift_JIS'#13#10#13#10;
      CD.dwData := 9801;
      CD.cbData := Length(Str);
      CD.lpData := PChar(Str);

      SendMessage(FHwnd,WM_COPYDATA,0,Integer(@CD));
      Break;
    end
  end;
  //MessageBox(0,'Thread End','a',0);
  FindCloseChangeNotification(handle);
end;

constructor TFileWatchThread3.Create(path,name:string;flag:DWORD;h:hwnd);
begin
  FPath := path;
  FName := name;
  FFlag := flag;
  FHwnd := h;
  FreeOnTerminate:=True;

  inherited Create(False);
end;
function GetToken(var p:PChar):String;
begin
  Result := '';
  while (p^ <> #0)and(p^ <> ' ') do
  begin
    if (p^ = #13)and((p+1)^ = #10) then
    begin
      Inc(p);
      break;
    end;
    if p^ in LeadBytes then
    begin
      Result := Result + p^ + (p+1)^;
      Inc(p,2);
    end else
    begin
      Result := Result + p^;
      Inc(p);
    end;
  end;
  Inc(p);
end;

{ export function }
function load(h:HGLOBAL;len:integer):bool;cdecl;export;
begin
  if list = nil then
    list := TThreadList.Create;
  Result := true;
end;

function unload:bool;cdecl;export;
begin
  if list <> nil then
  begin
    list.Free;
    list := nil;
  end;
  Result := true;
end;

function request(h:HGLOBAL;var len:integer):HGLOBAL;cdecl;export;
var
 i:integer;
 req,res,cmd:string;
 arg:array[0..4] of string;
 p:PChar;
begin
  setlength(req,len);
  p := PChar(req);
  MoveMemory(p,Pointer(h),len);
  GlobalFree(h);
  Res := 'SAORI/1.0 500 Internal Server Error'#13#10#13#10;

  for i:=0 to 4 do
    arg[i] := '';

  cmd:=GetToken(p);
  if cmd = 'GET' then
  begin
    cmd:=GetToken(p);
    if cmd = 'Version' then
    begin
      if GetToken(p) = 'SAORI/1.0' then
      begin
        Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
      end
      else
      begin
        Res := 'SAORI/1.0 400 Bad Request'#13#10+
               'Charset: Shift_JIS'#13#10#13#10;
      end;
    end
    else
    begin
      Res := 'SAORI/1.0 400 Bad Request'#13#10+
             'Charset: Shift_JIS'#13#10#13#10;
    end;
  end
  else if cmd = 'EXECUTE' then
  begin
    if GetToken(p) = 'SAORI/1.0' then
    begin
      while p^ <> #0 do
      begin
        cmd:=GetToken(p);
        if StrLComp('Argument',PChar(cmd),8) = 0 then
        begin
           Delete(cmd,1,8);
           Delete(cmd,Length(cmd),1);
           i:=StrToIntDef(cmd,-1);
           if (0 <= i)and(i <= 4) then
           begin
             arg[i]:=GetToken(p);
           end;
        end;
      end;

      if arg[0] = 'StartFileWatch' then
      begin
        //MessageBox(0,'StartFileWatch','a',0);
        if (arg[1] <> '')and(arg[4] <> '') then
        begin
          i := StrToIntDef(arg[4],-1);
          if i = -1 then
          begin
            Res := 'SAORI/1.0 400 Bad Request'#13#10+
                   'Charset: Shift_JIS'#13#10#13#10;
          end
          else
          begin
            //MessageBox(0,PChar(BoolToStr(StrToBoolDef(arg[2],false),true)),PChar(arg[2]+' '+IntTostr(Length(arg[2]))),MB_OK);
            if FileExists(arg[1]) then
            begin
              i:=list.Add(TFileWatchThread3.Create(ExtractFileDir(arg[1]),ExtractFileName(arg[1]),
                  StrToIntDef(arg[3],FILE_NOTIFY_CHANGE_FILE_NAME or
                      FILE_NOTIFY_CHANGE_SIZE or FILE_NOTIFY_CHANGE_LAST_WRITE
                  ),i));
            end
            else
            begin
              i:=list.Add(TFileWatchThread.Create(arg[1],StrToBoolDef(arg[2],false),
                  StrToIntDef(arg[3],
                      FILE_NOTIFY_CHANGE_FILE_NAME or FILE_NOTIFY_CHANGE_DIR_NAME or
                      FILE_NOTIFY_CHANGE_SIZE or FILE_NOTIFY_CHANGE_LAST_WRITE
                  ),i));
            end;
            Res := 'SAORI/1.0 200 OK'#13#10+
                   'Result: '+IntTostr(i)+#13#10+
                   'Charset: Shift_JIS'#13#10#13#10;
          end;
        end
        else
        begin
          Res := 'SAORI/1.0 400 Bad Request'#13#10+
                 'Charset: Shift_JIS'#13#10#13#10;
        end;
      end
      else if arg[0] = 'StopFileWatch' then
      begin
        //MessageBox(0,'StopFileWatch',PChar(arg[1]),0);
        if (arg[1] <> '') then
        begin
          i := StrToIntDef(arg[1],-1);
          //MessageBox(0,PChar(IntToStr(i)),PChar(IntToStr(Length(arg[1]))),0);
          if i = -1 then
          begin
            Res := 'SAORI/1.0 400 Bad Request'#13#10+
                   'Charset: Shift_JIS'#13#10#13#10;
          end
          else
          begin
            list.Delete(i);
            Res := 'SAORI/1.0 204 No Content'#13#10#13#10;
          end;
        end
        else
        begin
          Res := 'SAORI/1.0 400 Bad Request'#13#10+
                 'Charset: Shift_JIS'#13#10#13#10;
        end;
      end
      else
      begin
        Res := 'SAORI/1.0 400 Bad Request'#13#10+
               'Charset: Shift_JIS'#13#10#13#10;
      end;
    end
    else
    begin
      Res := 'SAORI/1.0 400 Bad Request'#13#10+
             'Charset: Shift_JIS'#13#10#13#10;
    end;
  end
  else
  begin
    Res := 'SAORI/1.0 400 Bad Request'#13#10+
           'Charset: Shift_JIS'#13#10#13#10;
  end;
  //MessageBox(0,PChar(Res),'a',0);
  len := Length(res);
  Result := GlobalAlloc(GMEM_FIXED or GMEM_ZEROINIT,len);
  MoveMemory(Pointer(result),PChar(res),len);
  Exit;
end;

exports
  load,unload,request;

begin
end.
 